const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const ai_models = sequelize.define(
    'ai_models',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

provider: {
        type: DataTypes.ENUM,
      
      

        values: [

"groq",


"gemini",


"deepseek",


"custom"

        ],

      },

model_name: {
        type: DataTypes.TEXT,
      
      

      },

base_url: {
        type: DataTypes.TEXT,
      
      

      },

default_config: {
        type: DataTypes.TEXT,
      
      

      },

typical_latency_ms: {
        type: DataTypes.INTEGER,
      
      

      },

is_enabled: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  ai_models.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






    db.ai_models.hasMany(db.api_keys, {
      as: 'api_keys_model',
      foreignKey: {
          name: 'modelId',
      },
      constraints: false,
    });




    db.ai_models.hasMany(db.fill_sessions, {
      as: 'fill_sessions_ai_model',
      foreignKey: {
          name: 'ai_modelId',
      },
      constraints: false,
    });







//end loop






    db.ai_models.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.ai_models.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return ai_models;
};


